/*
PolyGun

Copyright (c) 2023 Solindek <ytsolindekttv@gmail.com>

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/

#include "game/audio/audio.hpp"

#include <al.h>
#include <alc.h>

#include "common/logger.hpp"

static struct {
    ALCcontext* context;
    ALCdevice* device;

    unsigned int main_source;
    unsigned int buffer;
} audio_structures;

namespace polygun::audio {

    void init() {
        audio_structures.device = alcOpenDevice(0);
        if (audio_structures.device == NULL) {
			LOG_ERROR("Couldn't open the device, audio won't be initalized");
			return;
		}

        audio_structures.context = alcCreateContext(audio_structures.device, 0);
        if (!alcMakeContextCurrent(audio_structures.context)) {
			LOG_ERROR("Couldn't make the context current, audio won't be initalized");
			alcCloseDevice(audio_structures.device);
			return;
		}
    }

	void cleanup() {
		alcMakeContextCurrent(nullptr);
		if(audio_structures.context)
			alcDestroyContext(audio_structures.context);
		if(audio_structures.device)
			alcCloseDevice(audio_structures.device);
	}
}
